/* [ioercode.h]																*/
/*																			*/
/* Copyright(C) 2002-2003, SHARP CORPORATION, All rights reserved.			*/
/*																			*/
/* This file is used for SL-series Zaurus PIM application. 		            */
/* This file is provided AS-IS for those who needs to know the details,		*/
/* and no technical support is assumed.			                            */

#ifndef _IOERCODE_H_INCLUDED


typedef long	ERRCODE;	

#define	SUCCESS		0	
#define	IOCS_ERROR	-1	

#define	SHIO_EC_BASE		0xEC000000

#define	MSGSVR_EC_BASE		0xEC140000	/* = (SHIO_EC_BASE+(20<<16)) */
#define	BCOMM_EC_BASE		0xEC150000	/* = (SHIO_EC_BASE+(21<<16)) */
#define	MDM_EC_BASE			0xEC160000	/* = (SHIO_EC_BASE+(22<<16)) */
#define	POINTDEV_EC_BASE	0xEC170000	/* = (SHIO_EC_BASE+(23<<16)) */
#define	SYSIO_EC_BASE		0xEC180000	/* = (SHIO_EC_BASE+(24<<16)) */
#define	FLASH_EC_BASE		0xEC190000	/* = (SHIO_EC_BASE+(25<<16)) */
#define USERDIC_EC_BASE		0xEC1a0000	/* = (SHIO_EC_BASE+(26<<16)) */
#define	PRIVENV_EC_BASE		0xEC1b0000	/* = (SHIO_EC_BASE+(27<<16)) */
#define	RTC_EC_BASE			0xEC1c0000	/* = (SHIO_EC_BASE+(28<<16)) */
#define	CAMERA_EC_BASE		0xEC1d0000	/* = (SHIO_EC_BASE+(29<<16)) */

#define	AD_DA_EC_BASE		0xEC1e0000	/* = (SHIO_EC_BASE+(30<<16)) */
#define	FAX_EC_BASE			0xEC1f0000	/* = (SHIO_EC_BASE+(31<<16)) */
#define	IRNET_EC_BASE		0xEC200000	/* = (SHIO_EC_BASE+(32<<16)) */
/* #define	_EC_BASE		0xEC210000	   = (SHIO_EC_BASE+(33<<16)) */
#define	ZXDM_EC_BASE		0xEC220000	/* = (SHIO_EC_BASE+(34<<16)) */

#define	COMMDEV_EC_BASE		0xEC320000	/* = (SHIO_EC_BASE+(50<<16)) */

#define	MISCTOOL_EC_BASE	0xEC620000	/* = (SHIO_EC_BASE+(98<<16)) */
#define	DIAG_EC_BASE		0xEC630000	/* = (SHIO_EC_BASE+(99<<16)) */
#define ZAC_EC_BASE			0xEC660000	
							
#define KEY_EC_BASE			0xEC870000	


#define	ESRPIOERR_BASE	0xEEFF0000	
#define	FCERR_BASE		0xEEFC0000	


#define FC_HARD_ERROR		 (FCERR_BASE+0x00)	
#define FC_VALUE_ERROR		 (FCERR_BASE+0x01)	
#define FC_NO_FILE_ERROR	 (FCERR_BASE+0x02)	
#define FC_NO_PATH_ERROR	 (FCERR_BASE+0x03)	
#define FC_MATCH_OPEN_ERROR	 (FCERR_BASE+0x04)	
#define FC_FILE_MODE_ERROR	 (FCERR_BASE+0x05)	
#define FC_BAD_HANDLE_ERROR	 (FCERR_BASE+0x06)	
#define FC_OPEN_MODE_ERROR	 (FCERR_BASE+0x07)	
#define FC_DUP_OPEN_ERROR	 (FCERR_BASE+0x08)	
#define FC_DUP_FILE_ERROR	 (FCERR_BASE+0x09)	
#define FC_NO_DRIVE_ERROR	 (FCERR_BASE+0x0a)	
#define FC_VERIFY_ERROR		 (FCERR_BASE+0x0b)	
#define FC_ENOUGH_SIZE_ERROR (FCERR_BASE+0x0c)	
#define	FC_NO_DATA_ERROR	 (FCERR_BASE+0x0d)	

#define FC_BAD_PATH_ERROR	 (FCERR_BASE+0x0e)	


#define	FC_BAD_COMMAND_ERROR (FCERR_BASE+0x23)	
#define FC_BAD_FILE_NAME_ERROR (FCERR_BASE+0x2a) 
 
#define FC_NO_DEVICE_ERROR	 (FCERR_BASE+0x0fa)	

#define FC_ABORT_ERROR		 (FCERR_BASE+0x0fe) 
#define FC_BREAK_ERROR		 (FCERR_BASE+0x0ff) 


#define FC_LOW_BATTERY_ERROR	FC_ABORT_ERROR	
#define FC_STOP_ERROR			FC_BREAK_ERROR


#define PROTECT_ERROR		(ESRPIOERR_BASE+0x20) 
#define NO_DRIVE_ERROR		(ESRPIOERR_BASE+0x21) 
#define NOT_READY_ERROR		(ESRPIOERR_BASE+0x22) 
#define BAD_COMMAND_ERROR	(ESRPIOERR_BASE+0x23) 

#define MEDIA_CHANGE_ERROR	(ESRPIOERR_BASE+0x24) 
#define WRITE_ERROR			(ESRPIOERR_BASE+0x25) 
#define READ_ERROR			(ESRPIOERR_BASE+0x26) 
#define VERIFY_SCTR_ERROR	(ESRPIOERR_BASE+0x27) 

#define CANT_WRITE_ERROR	(ESRPIOERR_BASE+0x28) 
#define CANT_READ_ERROR		(ESRPIOERR_BASE+0x29) 
#define BAD_FILE_NAME_ERROR	(ESRPIOERR_BASE+0x2a) 
 
#define LOW_BATTERY_ERROR	(ESRPIOERR_BASE+0x0fe) 
#define STOP_ERROR			(ESRPIOERR_BASE+0x0ff) 


#define _IOERCODE_H_INCLUDED
#endif

/* end of ioercode.h */

