/* [zdtmtypes.h]																*/
/*																			*/
/* Copyright(C) 2002-2003, SHARP CORPORATION, All rights reserved.			*/
/*																			*/
/* This file is used for SL-series Zaurus PIM application. 		            */
/* This file is provided AS-IS for those who needs to know the details,		*/
/* and no technical support is assumed.			                            */

#ifndef _ZDTMTYPES_H_INCLUDED
#define _ZDTMTYPES_H_INCLUDED


#include "ctgry.h"

typedef unsigned char DATATYPE;
#define	DATA_ID_CODE		0x01	
#define	DATA_ID_IMAGE		0x02	
#define	DATA_ID_HTEXT		0x03	
#define	DATA_ID_TIME		0x04	
#define	DATA_ID_JIKAN		0x05	
#define	DATA_ID_BIT	       	0x06	
#define	DATA_ID_WEEK		0x07	
#define	DATA_ID_UINT		0x08	
#define	DATA_ID_BINARY		0x09	
#define	DATA_ID_UINT_GS		0x0a	
#define	DATA_ID_UCHAR		0x0b	
#define	DATA_ID_BARRAY		0x0c	
#define	DATA_ID_COLOR		0x0d	
#define DATA_ID_SXLS		0x0e	
#define DATA_ID_SRTF		0x0f	
#define DATA_ID_STXT		0x10	

#define DATA_ID_UTF8		0x11

#define DATA_ID_ULONG		0x12

#define DATA_ID_SJIS		DATA_ID_CODE

#define	DATA_ID_WORD		DATA_ID_UINT
#define	DATA_ID_WORD_GS		DATA_ID_UINT_GS


#define	SYS_CTGR_ITEM_NAME	(const char*)"CTGR"	
#define	SYS_ATTR_ITEM_NAME	(const char*)"ATTR"	
#define	SYS_CTTM_ITEM_NAME	(const char*)"CTTM"	
#define	SYS_MDTM_ITEM_NAME	(const char*)"MDTM"	
#define	SYS_SYID_ITEM_NAME	(const char*)"SYID"	

#define	SYS_LKIF_ITEM_NAME	(const char*)"LKIF"	
#define	SYS_LKDT_ITEM_NAME	(const char*)"LKDT"	

typedef unsigned char CONVTYPE;
typedef enum CONVID {
	CONV_ID_UNKNOWN = 0,	
	CONV_ID_WZTEXT,		
	CONV_ID_SJIS1,		
	CONV_ID_SJIS2,		
	CONV_ID_SJIS3,		
	CONV_ID_CHKMARK,	
	CONV_ID_TIME,		
	CONV_ID_WEEK,		
	CONV_ID_CATEGORY,	
	CONV_ID_ALARMSW,	
	CONV_ID_ATTRIB,		
	CONV_ID_3TO4,		
	CONV_ID_BAHEX2,		
	CONV_ID_1BHEX2,		
	CONV_ID_1WHEX4,		
	CONV_ID_1LHEX8,		
	CONV_ID_LATITUDE,	
	CONV_ID_LONGITUDE,	
	CONV_ID_UTF8,		
    CONV_ID_IGNORE = 255    
} CONVID;


/*======================================================================
======================================================================*/

#define	INDEX_FIRST_BYTE	0xfe


#define	INDEX_SHOUJUN		0x80	
#define	INDEX_KOUJUN		0x81	
#define	INDEX_CODE_SHOUJUN	0x82	
#define	INDEX_CODE_KOUJUN	0x83	
#define	INDEX_GOKAN_SHOUJUN	0x8C	
#define	INDEX_GOKAN_KOUJUN	0x8D	

#define	INDEX_ONAJI		0x90	
#define	INDEX_SENTOU	0x91	
#define	INDEX_FUKUMU	0x92	
#define	INDEX_F_IJOU	0x96	
#define	INDEX_F_IKA		0x97	
#define	INDEX_IJOU		0x98	
#define	INDEX_CHOUKA	0x99	
#define	INDEX_IKA		0x9a	
#define	INDEX_MIMAN		0x9b	
#define	INDEX_ARI		0x9e	
#define	INDEX_NASHI		0x9f	


#define	INDEX_ONAJI		0x90	
#define	INDEX_IJOU		0x98	
#define	INDEX_CHOUKA	0x99	
#define	INDEX_IKA		0x9a	
#define	INDEX_MIMAN		0x9b	

#define	INDEX_BIT_TRUE		0x88
#define	INDEX_BIT_FALSE		0x89

#define	INDEX_SAME_DATA		0x94
#define	INDEX_SAME_DATA_LIMITED	0x96	


#define	INDEX_DATA_AND		0x84
#define	INDEX_DATA_OR		0x85


#define	INDEX_ITEM_AND		0x86
#define	INDEX_ITEM_OR		0x87


#define	INDEX_BINARY_STR	0x95
#define INDEX_NOT_WILD_TIME_WEEK	0x95

#define	DTM_SEARCH_FORWARD	0
#define	DTM_SERACH_BACKWARD	1	
#define	DTM_SEARCH_BACKWARD	1

#define	EQUAL_IS_TRUE		0
#define	UNEQUAL_IS_TRUE		1

#endif /* _ZDTMTYPES_H_INCLUDED */

